<?php
require("../adei.php");

header("Content-type: text/xml");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

try {
    $req = new SOURCERequest($_GET);

    $reader = $req->CreateReader();
    $list = $reader->GetGroupList();
    unset($reader);

    if (!count($list)) $error = translate("No LogGroups is found");
} catch (ADEIException $ex) {
    $error = xml_escape($ex->getMessage());
}

echo "<?xml version=\"1.0\"?>\n";
if ($error) echo "<result><Error>$error</Error></result>";
else {
    echo "<result>";
    foreach ($list as $value=>$db) {
	echo "<Value name=\"" . xml_escape($db['name']) . "\" value=\"" . $value . "\"/>";
    }
    echo "</result>";
}

?>