<?php
require("../adei.php");

header("Content-type: text/xml");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");


try {
    $req = new GROUPRequest($_GET);
    $reader = $req->CreateReader();

    $items = $reader->GetItemList();
    foreach (array_keys($items) as $i) {
	if ($i) $all .= "," . $i;
	else $all = $i;
    }
    unset($items);
    
    $list = $reader->GetMaskList();
    unset($reader);
} catch (ADEIException $ex) {
    $error = xml_escape($ex->getMessage());
}
echo "<?xml version=\"1.0\"?>\n";
if ($error) echo "<result><Error>$error</Error></result>";
else {
    echo "<result>";
    echo "<Value name=\"" . _("All") . "\" value=\"$all\"/>";
    foreach ($list as $value => $db) {
	$name = xml_escape($db['name']);
	echo "<Value name=\"$name\" value=\"" . $value . "\"/>";
    }
    echo "<Value name=\"" . _("Standalone Item") . "\" value=\"-1\"/>";
    echo "</result>";
}

?>