<?php
require("../adei.php");

header("Content-type: text/xml");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");


try {
    $req = new SERVERRequest($_GET);

    $reader = $req->CreateReader();
    $dblist = $reader->GetDatabaseList();
    unset($reader);
    
    if (!count($dblist)) $error = translate("No database is found");
} catch (ADEIException $ex) {
    $error = xml_escape($ex->getMessage());
}


echo "<?xml version=\"1.0\"?>\n";
if ($error) echo "<result><Error>$error</Error></result>";
else {
    echo "<result>";
    foreach ($dblist as $db => $val) {
	echo "<Value name=\"" . $val['name'] . "\" value=\"$db\"/>";
    }
    echo "</result>";
}

?>