<?php
require("../adei.php");

header("Content-type: text/xml");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

try {
    $req = new SOURCERequest($_GET);

    $reader = $req->CreateReader();
    $list = $reader->GetExperimentList();
    unset($reader);
} catch (ADEIException $ex) {
    $error = xml_escape($ex->getMessage());
}

echo "<?xml version=\"1.0\"?>\n";
if ($error) echo "<result><Error>$error</Error></result>";
else {
    echo "<result>";
    echo "<Value name=\"" . _("Everything") . "\" value=\"0-0\"/>";
    echo "<Value name=\"" . _("Custom") . "\" value=\"0\"/>";
    foreach ($list as $db) {
	echo "<Value name=\"" . $db['name'] . "\" value=\"" . $db['start'] . '-' . $db['stop'] . "\"/>";
    }
    echo "</result>";
}

?>