<?php
require("../adei.php");

header("Content-type: text/xml");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

try {
    $req = new GROUPRequest($_GET);
    $reader = $req->CreateReader();
    $list = $reader->GetItemList();
    unset($reader);
} catch (ADEIException $ex) {
    $error = xml_escape($ex->getMessage());
}


echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
if ($error) echo "<result><Error>$error</Error></result>";
else {
    echo "<result>";
    foreach ($list as $value => $info) {
	$name = xml_escape($info['name']);
	echo "<Value name=\"" . $name . "\" value=\"" . $value . "\"/>";
    }
    echo "</result>";
}

?>