<?php
require("../adei.php");

header("Content-type: application/json");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");


/*
$props = new 

if (isset($_POST['props']))
    $props = json_decode(stripslashes($_POST['props']), true);
else
//    $error = _("Configuration is missing");
*/

/*
$f = fopen("/tmp/xxx", "w");
fprintf($f, time() . "\n");
fprintf($f, print_r($_POST['props'], true) . ".\n");
fprintf($f, print_r($props, true) . ".\n");
fprintf($f, addslashes(json_encode(array(
	"error" => 0,
	"draw" => 1,
	"image" => 0
    ))));
fclose($f);
$_POST['props'] = "{\"db_server\": \"hs\", \"db_name\": \"experiment1\", \"db_group\": \"0\", \"db_mask\": \"4\", \"experiment\": \"0-0\", \"window\": \"0\", \"frame_width\": 864, \"frame_height\": 616}";
*/

try {
    $req = new REQUEST();
    if ($req->CheckData()) {

	$req = $req->CreateDataRequest();

	$draw = new DRAW($req);
	$draw->Create();
	$file = $draw->Save();
	$scale = $draw->GetScaleInfo();
    } else {
	$draw = new WELCOME($req);
	$draw->Create();
	$file = $draw->Save();
	$no_data = true;
    }
} catch(ADEIException $e) {
    $error = $e->getMessage();

    if ($e->getCode() == ADEIException::NO_DATA) {
	try {
	    $no_data = true;
	    $draw->CreateMessage("Error", $error);
	    $file = $draw->Save();
	    $error = false;
	} catch (ADEIException $ex) {
	    $no_data = false;
	}
    }
}

if ($error) {
    echo json_encode(array("error" => $error));
} else {
    if ($draw) {
	if ($no_data) {
	    echo json_encode(array(
		"module" => "graph",
		"nodata" => true,
		"draw" => 1,
		"image" => $file
	    ));
	} else {
	    echo json_encode(array_merge(array(
		"error" => 0,
		"module" => "graph",
		"draw" => 1,
		"image" => $file
	    ), $scale));
	}
    } else {
	echo json_encode(array(
	    "error" => 0
	));
    }
}


?>