<?php
    $dh = opendir("setups/");
     while (($subdir = readdir($dh)) !== false) {
        if (!is_dir("setups/$subdir")||($subdir == $SETUP)||(!strncmp($subdir,".",1))) continue;
	
	if (is_file("setups/$subdir/config.php")&&(!is_file("setups/$subdir/.exclude")))
	    include("setups/$subdir/config.php");
     }

    $TITLE = "ADEI";
    $MODULES = array("config", "graph", "help");

    $EXPORT_FORMATS = array (
	"csv" => array(
	    'title' => "CSV",
	),
	"xls" => array(
	    'title' => "Excel",
	    'handler' => "EXCEL",
	),
	"root" => array(
	    'title' => "ROOT",
	    'filter' => array (
		'app' => "csv2root",
		'opts' => "--file @TMPFILE@ ?{@BLOCK_NUMBER@===0?--overwrite} ?{@EXPECTED_BLOCKS@!=1?--group @BLOCK_TITLE@}",
		'joiner' => true,
		'groupmode' => true,	/* Run filter app for each group */
	        'extension' => "root"
	    )
	),
	"root_hist" => array(
	    'title' => "ROOT+Hist",
	    'filter' => array(
		'app' => "csv2root",
		'opts' => "--file @TMPFILE@ ?{@BLOCK_NUMBER@===0?--overwrite} ?{@EXPECTED_BLOCKS@!=1?--group @BLOCK_TITLE@} --save-histograms ?{@ROOT__COMBHIST@?--combined-histogram}",
		'joiner' => true,
		'groupmode' => true,	/* Run filter app for each block */
		'extension' => "root"
	    )
	)
    );

?>