<?php

$TITLE = "";
$MODULES = array("config", "graph", "alarms", "logs", "help");

/*
$EXPORT_FORMATS = array (
	"csv" => array(
	    'title' => "CSV",
	),
	"xls" => array(
	    'title' => "Excel",
	    'handler' => "EXCEL",
	)
);
*/

$READER_DB_KATRIN = array(
	"katrin" => array (
	    "title" => _("HauptSpektrometer"),
	    "reader" => "ZEUS",
	    "driver" => "mysql",
	    "host" => "localhost",
	    "port" => 0,
	    "user" => "zeus",
	    "password" => "zeus",
	    "database" => array ("hauptspektrometer")
	),
/*	"detector" => array (
	    "title" => _("Detector"),
	    "reader" => "ZEUS",
	    "driver" => "mysql",
	    "host" => "ipedonner2.ka.fzk.de",
	    "port" => 0,
	    "user" => "katrinpse",
	    "password" => "katrinpse",
	    "database" => array("katrin-detector2")
	),*/
	"katrindb" => array (
	    "title" => _("PreSpektrometer Zeus7"),
	    "reader" => "ZEUS",
	    "driver" => "mysql",
	    "host" => "ipekatrindb.fzk.de",
	    "port" => 0,
	    "user" => "katrinpse",
	    "password" => "katrinpse",
	    "database" => array ("katrinpse_current"),
//	    "database" => array ("katrinpse_current", "katrinpse_archiv_20080331", "katrinpse_archiv_20071221"),
//	    "disconnected" => true
	),
	"toskanadb" => array (
	    "title" => _("PreSpektrometer Zeus8"),
	    "reader" => "ZEUS",
	    "driver" => "odbc",
	    "sqldrv" => "mssql",
	    "subdrv" => "FreeTDS",
	    "host" => "192.168.8.6",
	    "port" => 0,
	    "user" => 'souren',
	    "password" => '$souren$',
	    "database" => array ("prespektrometer_rep")
	)
	    
);

if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_KATRIN, $READER_DB);
else $READER_DB = $READER_DB_KATRIN;

$OPTIONS["katrindb"] = array(
	    "optimize_empty_cache" => true,
//	    "graph_interpolate" => false,
	    "maximal_allowed_gap" => 120,
	    "ignore_invalid_data" => true
);

$OPTIONS["toskanadb"] = array(
	    "root_database" => "/var/www/localhost/htdocs/adei/storage/root_prespektrometer.root",
	    "date_limit" => "2008-04-21 12:00:00",              //GMT
	    "optimize_empty_cache" => true,
//	    "graph_interpolate" => false,
	    "maximal_allowed_gap" => 120,
//	    "ignore_invalid_data" => true,
//	    "fill_raw_first" => true,
	    "fix_missing_items" => array(
		"check_growth" => true,	/* check amount of items not to decrease */
		"limit" => 1,		/* minimal amount of items required */
		"value" => 0
	    ),
	    "fix_extra_items" => true
);

$OPTIONS["katrin__hauptspektrometer"] = array(
	    "backup" => "backup_hauptspektrometer",
	    "optimize_empty_cache" => true,
//	    "graph_interpolate" => false,
	    "maximal_allowed_gap" => 120
);


$OPTIONS["detector"] = array(
    "use_cache_reader" => false,// Do not access data source while reading cache
    "overcome_reader_faults" => false,  // Use CACHE if connection to reader is failed 
);

?>