<?php
require("../adei.php");

/*
$config = array (
    "db_server" => "katrin",
    "db_name" => "hauptspektrometer"
);
*/

function DoClean(&$req) {
    try {
	$reader = $req->CreateReader(REQUEST::READER_FORBID_CACHEREADER);

	$list = $req->GetGroupList();
	foreach ($list as $greq) {
	    $lg = $reader->CreateGroup($greq->GetGroupInfo());
	    $reader->Clean($lg);
	}
    } catch(ADEIException $e) {
	$error = $e->getMessage();
    }

    return $error?$error:0;
}

$req = new REQUEST($config);
$list = $req->GetSourceList();

foreach ($list as $sreq) {
    $err = DoClean($sreq);
    if ($err) 
	echo $sreq->GetLocationString() . ", Error: $err\n";
}

?>